import numpy as np
import matplotlib.pyplot as plt
from scipy.io import loadmat
from scipy.sparse.linalg import svds

# load data
data = loadmat("mnistSubset.mat")
X = data['X']
trueLabels = data['trueLabels'][:,0]

# only consider digits 1 and 2 (labels 2 and 3)
K = 2
Xtrain = np.array([]).reshape(784, 0)
ytrain = np.array([]).reshape(0, 1)
Xtest = np.array([]).reshape(784, 0)
ytest = np.array([]).reshape(0, 1)
for kk in range(1,K+1):
    Xk = X[:, np.argwhere(trueLabels==kk+1)[:,0]]
    Xtrain = np.append(Xtrain, Xk[:, :100], axis=1)
    Xtest = np.append(Xtest, Xk[:, 100:], axis=1)
    ytrain = np.append(ytrain, kk*np.ones([100, 1]), axis=0)
    ytest = np.append(ytest, kk*np.ones([100, 1]), axis=0)

# make labels +1/-1
ytrain = (2*(ytrain - 1) - 1)[:,0]
ytest = (2*(ytest - 1) - 1)[:,0]

# ridge regression parameter
lam = 1e-3

## YOUR CODE
# train LS classifier on Xtrain/ytrain
# report both training and test error

# reduce dimension of data using PCA and plot

# classify dimension-reduced data using least squares

## plot LS separator with data
#minX = np.min(Ztrain[0,:])
#maxX = np.max(Ztrain[0,:])
#xx = np.linspace(minX,maxX,100)
#yy = -w[0]*xx/w[1]
#plt.plot(xx,yy, label='LS separator')
#plt.legend()
#plt.show()
